<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id= "table-users" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        
      </tbody>
    </table>
  </div>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  //gán sự kiện cho nút detail
    $(".user-detail").on("click", function(){
          onBtnDetailClick(this);
        });
  });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý việc tải trang
    function onPageLoading(){
      var vUsersObj = JSON.parse(gJsonUser);
      loadDataToUserTable(vUsersObj.users);
    }
    function onBtnDetailClick(paramButton){
      console.log("Nút chi tiết được ấn");
      var vUserId = $(paramButton).data("userid");
      var vFirstName = $(paramButton).data("firstname");
      var vLastName = $(paramButton).data("lastname");
      var vAge = $(paramButton).data("age");
      console.log("User id: " + vUserId);
      console.log("First name: " + vFirstName);
      console.log("Last name: " + vLastName);
      console.log("Age: " + vAge);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load dữ liệu vào user data table
    function loadDataToUserTable(paramUsers){
      var vUserTable = $("#table-users");
      for (var bI =0; bI <paramUsers.length; bI++){
        //thêm dòng mới và gắn vào table
        var bNewRow = $("<tr>").appendTo(vUserTable);
        //thêm các ô, gắn vào dòng trên và điền dữ liệu innerHTML cho từng ô
        $("<td>", {html: paramUsers[bI].userId}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].firstname}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].lastname}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].age}).appendTo(bNewRow);
        //ô action
        var bActionCell = $("<td>").appendTo(bNewRow);
        var bDetailButton = $("<button>", {
          html: "Chi tiết",
          class: "btn btn-primary user-detail"
        }).data("userid", paramUsers[bI].userId)
        .data("firstname", paramUsers[bI].firstname)
        .data("lastname", paramUsers[bI].lastname)
        .data("age", paramUsers[bI].age)
        .appendTo(bActionCell);
      }
    }
    //cách 2 dùng chuỗi thay vì câu lệnh
     //hàm load dữ liệu vào user data table
     function loadDataToUserTable2(paramUsers){
      var vUserTable = $("#table-users");
      for (var bI =0; bI <paramUsers.length; bI++){
        //thêm dòng mới và gắn vào table
        var bNewRow = `
        <tr>
          <td>`+  paramUsers[bI].userId + `</td>
          <td>` + paramUsers[bI].firstname + `</td>
          <td>` + paramUsers[bI].lastname + `</td>
          <td>` + paramUsers[bI].age + `</td>
          <td>
            <button class="btn btn-primary">Chi tiết</button>
          </td>
        </tr>`;
        vUserTable.append(bNewRow);
      }
    }
  </script>
</body>

</html>
​